#ifndef GOSU_BUTTONSMAC_HPP
#define GOSU_BUTTONSMAC_HPP

namespace Gosu
{
    //! List of button ids that can be used with Gosu::Input.
    //! This enumeration contains ids for keyboard keys (kb*),
    //! mouse buttons and mouse wheel (ms*) and gamepad buttons (gp*).
    enum ButtonName
    {
        kbRangeBegin = 0x00,
        kbEscape = 0x35,
        kbF1 = 0x7a,
        kbF2 = 0x78,
        kbF3 = 0x63,
        kbF4 = 0x76,
        kbF5 = 0x60,
        kbF6 = 0x61,
        kbF7 = 0x62,
        kbF8 = 0x64,
        kbF9 = 0x65,
        kbF10 = 0x6d,
        kbF11 = 0x67,
        kbF12 = 0x6f,
        kb1 = 0x12,
        kb2 = 0x13,
        kb3 = 0x14,
        kb4 = 0x15,
        kb5 = 0x17,
        kb6 = 0x16,
        kb7 = 0x1a,
        kb8 = 0x1c,
        kb9 = 0x19,
        kb0 = 0x1d,
        kbA	= 0x00,
        kbB	= 0x0b,
        kbC	= 0x08,
        kbD	= 0x02,
        kbE	= 0x0e,
        kbF	= 0x03,
        kbG	= 0x05,
        kbH	= 0x04,
        kbI	= 0x22,
        kbJ	= 0x26,
        kbK	= 0x28,
        kbL	= 0x25,
        kbM	= 0x2e,
        kbN	= 0x2d,
        kbO	= 0x1f,
        kbP	= 0x23,
        kbQ	= 0x0c,
        kbR	= 0x0f,
        kbS	= 0x01,
        kbT	= 0x11,
        kbU	= 0x20,
        kbV	= 0x09,
        kbW	= 0x0d,
        kbX	= 0x07,
        kbY	= 0x10,
        kbZ	= 0x06,
        kbTab = 0x30,
        kbReturn = 0x24,
        kbSpace = 0x31,
        kbLeftShift = 0x38,
        kbRightShift = 0x3c,
        kbLeftControl = 0x3b,
        kbRightControl = 0x3e,
        kbLeftAlt = 0x3a,
        kbRightAlt = 0x3d,
        kbLeftMeta = 0x37,
        kbRightMeta = 0x36,
        kbBackspace = 0x33,
        kbLeft = 0x7b,
        kbRight = 0x7c,
        kbUp = 0x7e,
        kbDown = 0x7d,
        kbHome = 0x73,
        kbEnd = 0x77,
        kbInsert = 0x72,
        kbDelete = 0x75,
        kbPageUp = 0x74,
        kbPageDown = 0x79,
        kbEnter = 0x4c,
        kbNumpad1 = 0x53,
        kbNumpad2 = 0x54,
        kbNumpad3 = 0x55,
        kbNumpad4 = 0x56,
        kbNumpad5 = 0x57,
        kbNumpad6 = 0x58,
        kbNumpad7 = 0x59,
        kbNumpad8 = 0x5b,
        kbNumpad9 = 0x5c,
        kbNumpad0 = 0x52,
        kbNumpadAdd = 0x45,
        kbNumpadSubtract = 0x4e,
        kbNumpadMultiply = 0x43,
        kbNumpadDivide = 0x4b,
        kbRangeEnd = 0xffff,
        
        msRangeBegin,
        msLeft = msRangeBegin,
        msRight,
        msMiddle,
        msWheelUp,
        msWheelDown,
        msRangeEnd,
        
        gpRangeBegin,
        gpLeft = gpRangeBegin,
        gpRight,
        gpUp,
        gpDown,
        gpButton0,
        gpButton1,
        gpButton2,
        gpButton3,
        gpButton4,
        gpButton5,
        gpButton6,
        gpButton7,
        gpButton8,
        gpButton9,
        gpButton10,
        gpButton11,
        gpButton12,
        gpButton13,
        gpButton14,
        gpButton15,

        gp0Left,
        gp0Right,
        gp0Up,
        gp0Down,
        gp0Button0,
        gp0Button1,
        gp0Button2,
        gp0Button3,
        gp0Button4,
        gp0Button5,
        gp0Button6,
        gp0Button7,
        gp0Button8,
        gp0Button9,
        gp0Button10,
        gp0Button11,
        gp0Button12,
        gp0Button13,
        gp0Button14,
        gp0Button15,
        
        gp1Left,
        gp1Right,
        gp1Up,
        gp1Down,
        gp1Button0,
        gp1Button1,
        gp1Button2,
        gp1Button3,
        gp1Button4,
        gp1Button5,
        gp1Button6,
        gp1Button7,
        gp1Button8,
        gp1Button9,
        gp1Button10,
        gp1Button11,
        gp1Button12,
        gp1Button13,
        gp1Button14,
        gp1Button15,
        
        gp2Left,
        gp2Right,
        gp2Up,
        gp2Down,
        gp2Button0,
        gp2Button1,
        gp2Button2,
        gp2Button3,
        gp2Button4,
        gp2Button5,
        gp2Button6,
        gp2Button7,
        gp2Button8,
        gp2Button9,
        gp2Button10,
        gp2Button11,
        gp2Button12,
        gp2Button13,
        gp2Button14,
        gp2Button15,
        
        gp3Left,
        gp3Right,
        gp3Up,
        gp3Down,
        gp3Button0,
        gp3Button1,
        gp3Button2,
        gp3Button3,
        gp3Button4,
        gp3Button5,
        gp3Button6,
        gp3Button7,
        gp3Button8,
        gp3Button9,
        gp3Button10,
        gp3Button11,
        gp3Button12,
        gp3Button13,
        gp3Button14,
        gp3Button15,
        
        gpRangeEnd = gp3Button15,
        
        numButtons = gpRangeEnd + 1,
        numGamepads = 4,
        noButton = 0xffffffff,
        
        kbNum = kbRangeEnd - kbRangeBegin + 1,
        msNum = msRangeEnd - msRangeBegin + 1,
        gpNum = gpRangeEnd - gpRangeBegin + 1,
        gpNumPerGamepad = gpNum / (numGamepads + 1),
    };
}
    
#endif
